Index: aim.c
===================================================================
--- aim.c	(revision fa4562c3dde208105e6938363d047e5622012e67)
+++ aim.c	(revision e19eb97bacd75cf02905ec2b7a6a73b9642b907a)
@@ -26,5 +26,5 @@
 };
 
-static char *msgerrreasons[] = {
+static const char *msgerrreasons[] = {
 	"Invalid error",
 	"Invalid SNAC",
@@ -136,5 +136,5 @@
 
 
-int owl_aim_login(char *screenname, char *password)
+int owl_aim_login(const char *screenname, const char *password)
 {
   struct owlfaim_priv *priv;
@@ -209,5 +209,5 @@
 
 /* stuff to run once login has been successful */
-void owl_aim_successful_login(char *screenname)
+void owl_aim_successful_login(const char *screenname)
 {
   char *buff;
@@ -248,5 +248,5 @@
 }
 
-void owl_aim_login_error(char *message)
+void owl_aim_login_error(const char *message)
 {
   if (message) {
@@ -261,5 +261,5 @@
 }
 
-int owl_aim_send_im(char *to, char *msg)
+int owl_aim_send_im(const char *to, const char *msg)
 {
   int ret;
@@ -271,5 +271,5 @@
 }
 
-int owl_aim_send_awaymsg(char *to, char *msg)
+int owl_aim_send_awaymsg(const char *to, const char *msg)
 {
   int ret;
@@ -281,5 +281,5 @@
 }
 
-void owl_aim_addbuddy(char *name)
+void owl_aim_addbuddy(const char *name)
 {
 
@@ -295,5 +295,5 @@
 }
 
-void owl_aim_delbuddy(char *name)
+void owl_aim_delbuddy(const char *name)
 {
   aim_ssi_delbuddy(owl_global_get_aimsess(&g), name, "Buddies");
@@ -301,5 +301,5 @@
 }
 
-void owl_aim_search(char *email)
+void owl_aim_search(const char *email)
 {
   int ret;
@@ -314,5 +314,5 @@
 
 
-int owl_aim_set_awaymsg(char *msg)
+int owl_aim_set_awaymsg(const char *msg)
 {
   int len;
@@ -341,5 +341,5 @@
 }
 
-void owl_aim_chat_join(char *name, int exchange)
+void owl_aim_chat_join(const char *name, int exchange)
 {
   int ret;
@@ -347,5 +347,5 @@
   /*
   OscarData *od = g->proto_data;
-  char *name, *exchange;
+  const char *name, *exchange;
   */
 
@@ -392,9 +392,9 @@
 }
 
-void owl_aim_chat_leave(char *chatroom)
-{
-}
-
-int owl_aim_chat_sendmsg(char *chatroom, char *msg)
+void owl_aim_chat_leave(const char *chatroom)
+{
+}
+
+int owl_aim_chat_sendmsg(const char *chatroom, const char *msg)
 {
   return(0);
@@ -402,5 +402,5 @@
 
 /* caller must free the return */
-char *owl_aim_normalize_screenname(char *in)
+char *owl_aim_normalize_screenname(const char *in)
 {
   char *out;
@@ -482,9 +482,9 @@
   struct client_info_s info = CLIENTINFO_AIM_KNOWNGOOD;
     
-  char *key;
-  va_list ap;
-
-  va_start(ap, fr);
-  key = va_arg(ap, char *);
+  const char *key;
+  va_list ap;
+
+  va_start(ap, fr);
+  key = va_arg(ap, const char *);
   va_end(ap);
 
@@ -706,9 +706,9 @@
   va_list ap;
   fu16_t code;
-  char *msg;
+  const char *msg;
   
   va_start(ap, fr);
   code = va_arg(ap, int);
-  msg = va_arg(ap, char *);
+  msg = va_arg(ap, const char *);
   va_end(ap);
   
@@ -740,5 +740,5 @@
   fu16_t change = 0, perms, type;
   int length, str;
-  char *val;
+  const char *val;
   va_list ap;
   
@@ -748,5 +748,5 @@
   type = (fu16_t)va_arg(ap, unsigned int);
   length = va_arg(ap, int);
-  val = va_arg(ap, char *);
+  val = va_arg(ap, const char *);
   str = va_arg(ap, int);
   va_end(ap);
@@ -900,9 +900,9 @@
 static int faimtest_parse_motd(aim_session_t *sess, aim_frame_t *fr, ...)
 {
-  char *msg;
+  const char *msg;
   fu16_t id;
   va_list ap;
   static int codeslen = 5;
-  static char *codes[] = {
+  static const char *codes[] = {
     "Unknown",
     "Mandatory upgrade",
@@ -914,5 +914,5 @@
   va_start(ap, fr);
   id = va_arg(ap, int);
-  msg = va_arg(ap, char *);
+  msg = va_arg(ap, const char *);
   va_end(ap);
 
@@ -1072,5 +1072,5 @@
   va_list ap;
   fu32_t offset, len;
-  char *modname;
+  const char *modname;
   unsigned char *buf;
   int buflen;
@@ -1079,5 +1079,5 @@
   offset = va_arg(ap, fu32_t);
   len = va_arg(ap, fu32_t);
-  modname = va_arg(ap, char *);
+  modname = va_arg(ap, const char *);
   va_end(ap);
   
@@ -1112,6 +1112,6 @@
 {
   aim_userinfo_t *userinfo;
-  char *prof_encoding = NULL;
-  char *prof = NULL;
+  const char *prof_encoding = NULL;
+  const char *prof = NULL;
   fu16_t inforeq = 0;
   owl_buddy *b;
@@ -1120,6 +1120,6 @@
   userinfo = va_arg(ap, aim_userinfo_t *);
   inforeq = (fu16_t)va_arg(ap, unsigned int);
-  prof_encoding = va_arg(ap, char *);
-  prof = va_arg(ap, char *);
+  prof_encoding = va_arg(ap, const char *);
+  prof = va_arg(ap, const char *);
   va_end(ap);
 
@@ -1497,10 +1497,10 @@
 {
   va_list ap;
-  char *destsn;
+  const char *destsn;
   fu16_t reason;
   
   va_start(ap, fr);
   reason = (fu16_t)va_arg(ap, unsigned int);
-  destsn = va_arg(ap, char *);
+  destsn = va_arg(ap, const char *);
   va_end(ap);
   
@@ -1518,10 +1518,10 @@
 {
   va_list ap;
-  char *destsn;
+  const char *destsn;
   fu16_t reason;
   
   va_start(ap, fr);
   reason = (fu16_t)va_arg(ap, unsigned int);
-  destsn = va_arg(ap, char *);
+  destsn = va_arg(ap, const char *);
   va_end(ap);
   
@@ -1534,5 +1534,5 @@
 static int faimtest_parse_misses(aim_session_t *sess, aim_frame_t *fr, ...)
 {
-  static char *missedreasons[] = {
+  static const char *missedreasons[] = {
     "Invalid (0)",
     "Message too large",
@@ -1566,9 +1566,9 @@
   va_list ap;
   fu16_t type;
-  char *sn = NULL;
+  const char *sn = NULL;
   
   va_start(ap, fr);
   type = (fu16_t)va_arg(ap, unsigned int);
-  sn = va_arg(ap, char *);
+  sn = va_arg(ap, const char *);
   va_end(ap);
   
@@ -1580,5 +1580,5 @@
 static int faimtest_parse_ratechange(aim_session_t *sess, aim_frame_t *fr, ...)
 {
-  static char *codes[5] = {
+  static const char *codes[5] = {
     "invalid",
     "change",
@@ -1656,12 +1656,12 @@
 {
   va_list ap;
-  char *address, *SNs;
+  const char *address, *SNs;
   int num, i;
   owl_list list;
   
   va_start(ap, fr);
-  address = va_arg(ap, char *);
+  address = va_arg(ap, const char *);
   num = va_arg(ap, int);
-  SNs = va_arg(ap, char *);
+  SNs = va_arg(ap, const char *);
   va_end(ap);
 
@@ -1681,8 +1681,8 @@
 {
   va_list ap;
-  char *address;
-  
-  va_start(ap, fr);
-  address = va_arg(ap, char *);
+  const char *address;
+  
+  va_start(ap, fr);
+  address = va_arg(ap, const char *);
   va_end(ap);
 
@@ -1696,10 +1696,10 @@
 {
   va_list ap;
-  char *msg, *url;
+  const char *msg, *url;
   fu16_t width, height, delay;
   
   va_start(ap, fr);
-  msg = va_arg(ap, char *);
-  url = va_arg(ap, char *);
+  msg = va_arg(ap, const char *);
+  url = va_arg(ap, const char *);
   width = va_arg(ap, unsigned int);
   height = va_arg(ap, unsigned int);
@@ -1722,9 +1722,9 @@
   va_list ap;
   aim_conn_t *bosconn;
-  char *bosip;
+  const char *bosip;
   fu8_t *cookie;
   
   va_start(ap, fr);
-  bosip = va_arg(ap, char *);
+  bosip = va_arg(ap, const char *);
   cookie = va_arg(ap, fu8_t *);
   va_end(ap);
@@ -1873,7 +1873,7 @@
   aim_userinfo_t *userinfo;
   struct aim_chat_roominfo *roominfo;
-  char *roomname;
+  const char *roomname;
   int usercount;
-  char *roomdesc;
+  const char *roomdesc;
   fu16_t flags, unknown_d2, unknown_d5, maxmsglen, maxvisiblemsglen;
   fu32_t creationtime;
@@ -1885,8 +1885,8 @@
   va_start(ap, fr);
   roominfo = va_arg(ap, struct aim_chat_roominfo *);
-  roomname = va_arg(ap, char *);
+  roomname = va_arg(ap, const char *);
   usercount = va_arg(ap, int);
   userinfo = va_arg(ap, aim_userinfo_t *);
-  roomdesc = va_arg(ap, char *);
+  roomdesc = va_arg(ap, const char *);
   flags = (fu16_t)va_arg(ap, unsigned int);
   creationtime = va_arg(ap, fu32_t);
@@ -1928,10 +1928,10 @@
   va_list ap;
   aim_userinfo_t *userinfo;
-  char *msg;
+  const char *msg;
   char tmpbuf[1152];
   
   va_start(ap, fr);
   userinfo = va_arg(ap, aim_userinfo_t *);	
-  msg = va_arg(ap, char *);
+  msg = va_arg(ap, const char *);
   va_end(ap);
 
Index: buddy.c
===================================================================
--- buddy.c	(revision d43edd2156ec9694ba4cec1c13baba690ce46b19)
+++ buddy.c	(revision e19eb97bacd75cf02905ec2b7a6a73b9642b907a)
@@ -1,5 +1,5 @@
 #include "owl.h"
 
-void owl_buddy_create(owl_buddy *b, int proto, char *name)
+void owl_buddy_create(owl_buddy *b, int proto, const char *name)
 {
   b->proto=proto;
@@ -8,5 +8,5 @@
 }
 
-char *owl_buddy_get_name(owl_buddy *b)
+const char *owl_buddy_get_name(owl_buddy *b)
 {
   if (b->name) return(b->name);
Index: buddylist.c
===================================================================
--- buddylist.c	(revision d43edd2156ec9694ba4cec1c13baba690ce46b19)
+++ buddylist.c	(revision e19eb97bacd75cf02905ec2b7a6a73b9642b907a)
@@ -8,5 +8,5 @@
 /* add a (logged-in) AIM buddy to the buddy list
  */
-void owl_buddylist_add_aim_buddy(owl_buddylist *bl, char *screenname)
+void owl_buddylist_add_aim_buddy(owl_buddylist *bl, const char *screenname)
 {
   owl_buddy *b;
@@ -19,5 +19,5 @@
 /* remove an AIM buddy from the buddy list
  */
-int owl_buddylist_remove_aim_buddy(owl_buddylist *bl, char *name)
+int owl_buddylist_remove_aim_buddy(owl_buddylist *bl, const char *name)
 {
   int i, j;
@@ -40,5 +40,5 @@
  * logged in.
  */
-void owl_buddylist_oncoming(owl_buddylist *bl, char *screenname)
+void owl_buddylist_oncoming(owl_buddylist *bl, const char *screenname)
 {
   owl_message *m;
@@ -66,5 +66,5 @@
  * has logged out, and sending a message if they were logged in.
  */
-void owl_buddylist_offgoing(owl_buddylist *bl, char *screenname)
+void owl_buddylist_offgoing(owl_buddylist *bl, const char *screenname)
 {
   owl_message *m;
@@ -103,5 +103,5 @@
  * no such buddy is logged in, return NULL.
  */
-owl_buddy *owl_buddylist_get_aim_buddy(owl_buddylist *bl, char *name)
+owl_buddy *owl_buddylist_get_aim_buddy(owl_buddylist *bl, const char *name)
 {
   int i, j;
@@ -119,5 +119,5 @@
  * otherwise return 0
  */
-int owl_buddylist_is_aim_buddy_loggedin(owl_buddylist *bl, char *screenname)
+int owl_buddylist_is_aim_buddy_loggedin(owl_buddylist *bl, const char *screenname)
 {
   owl_buddy *b;
Index: cmd.c
===================================================================
--- cmd.c	(revision fa4562c3dde208105e6938363d047e5622012e67)
+++ cmd.c	(revision e19eb97bacd75cf02905ec2b7a6a73b9642b907a)
@@ -38,5 +38,5 @@
 }
 
-owl_cmd *owl_cmddict_find(owl_cmddict *d, char *name) {
+owl_cmd *owl_cmddict_find(owl_cmddict *d, const char *name) {
   return owl_dict_find_element(d, name);
 }
@@ -47,5 +47,5 @@
 
 /* creates a new command alias */
-int owl_cmddict_add_alias(owl_cmddict *cd, char *alias_from, char *alias_to) {
+int owl_cmddict_add_alias(owl_cmddict *cd, const char *alias_from, const char *alias_to) {
   owl_cmd *cmd;
   cmd = owl_malloc(sizeof(owl_cmd));
@@ -65,5 +65,5 @@
 }
 
-char *_owl_cmddict_execute(owl_cmddict *cd, owl_context *ctx, char **argv, int argc, char *buff) {
+char *_owl_cmddict_execute(owl_cmddict *cd, owl_context *ctx, const char *const *argv, int argc, const char *buff) {
   char *retval = NULL;
   owl_cmd *cmd;
@@ -78,5 +78,5 @@
 }
 
-char *owl_cmddict_execute(owl_cmddict *cd, owl_context *ctx, char *cmdbuff) {
+char *owl_cmddict_execute(owl_cmddict *cd, owl_context *ctx, const char *cmdbuff) {
   char **argv;
   int argc;
@@ -103,5 +103,5 @@
 }
 
-char *owl_cmddict_execute_argv(owl_cmddict *cd, owl_context *ctx, char **argv, int argc) {
+char *owl_cmddict_execute_argv(owl_cmddict *cd, owl_context *ctx, const char *const *argv, int argc) {
   char *buff, *ptr;
   int len = 0, i;
@@ -143,5 +143,5 @@
 }
 
-int owl_cmd_create_alias(owl_cmd *cmd, char *name, char *aliased_to) {
+int owl_cmd_create_alias(owl_cmd *cmd, const char *name, const char *aliased_to) {
   memset(cmd, 0, sizeof(owl_cmd));
   cmd->name = owl_strdup(name);
@@ -167,8 +167,8 @@
 }
 
-char *owl_cmd_execute(owl_cmd *cmd, owl_cmddict *cd, owl_context *ctx, int argc, char **argv, char *cmdbuff) {
+char *owl_cmd_execute(owl_cmd *cmd, owl_cmddict *cd, owl_context *ctx, int argc, const char *const *argv, const char *cmdbuff) {
   static int alias_recurse_depth = 0;
   int ival=0;
-  char *cmdbuffargs;
+  const char *cmdbuffargs;
   char *newcmd, *rv=NULL;
 
@@ -206,5 +206,5 @@
 
   if (cmd->cmd_i_fn || cmd->cmd_ctxi_fn) {
-      char *ep = "x";
+      const char *ep = "x";
       if (argc != 2) {
 	owl_function_makemsg("Wrong number of arguments for %s command.", argv[0]);
@@ -238,5 +238,5 @@
 
 /* returns a reference */
-char *owl_cmd_get_summary(owl_cmd *cmd) {
+const char *owl_cmd_get_summary(owl_cmd *cmd) {
   return cmd->summary;
 }
@@ -255,6 +255,6 @@
 
 
-void owl_cmd_get_help(owl_cmddict *d, char *name, owl_fmtext *fm) {
-  char *s;
+void owl_cmd_get_help(owl_cmddict *d, const char *name, owl_fmtext *fm) {
+  const char *s;
   char *indent;
   owl_cmd *cmd;
Index: commands.c
===================================================================
--- commands.c	(revision fa4562c3dde208105e6938363d047e5622012e67)
+++ commands.c	(revision e19eb97bacd75cf02905ec2b7a6a73b9642b907a)
@@ -5,5 +5,5 @@
 #include "owl.h"
 
-/* fn is "char *foo(int argc, char **argv, char *buff)" */
+/* fn is "char *foo(int argc, const char *const *argv, const char *buff)" */
 #define OWLCMD_ARGS(name, fn, ctx, summary, usage, description) \
         { name, summary, usage, description, ctx, \
@@ -24,8 +24,8 @@
           actualname, NULL, NULL, NULL, NULL, NULL, NULL, NULL }
 
-/* fn is "char *foo(void *ctx, int argc, char **argv, char *buff)" */
+/* fn is "char *foo(void *ctx, int argc, const char *const *argv, const char *buff)" */
 #define OWLCMD_ARGS_CTX(name, fn, ctx, summary, usage, description) \
         { name, summary, usage, description, ctx, \
-          NULL, NULL, NULL, NULL, ((char*(*)(void*,int,char**,char*))fn), NULL, NULL, NULL }
+          NULL, NULL, NULL, NULL, ((char*(*)(void*,int,const char*const *,const char*))fn), NULL, NULL, NULL }
 
 /* fn is "void foo(void)" */
@@ -1004,5 +1004,5 @@
 }
 
-char *owl_command_help(int argc, char **argv, char *buff)
+char *owl_command_help(int argc, const char *const *argv, const char *buff)
 {
   if (argc!=2) {
@@ -1015,8 +1015,8 @@
 }
 
-char *owl_command_zlist(int argc, char **argv, char *buff)
+char *owl_command_zlist(int argc, const char *const *argv, const char *buff)
 {
   int elapsed=0, timesort=0;
-  char *file=NULL;
+  const char *file=NULL;
 
   argc--;
@@ -1076,5 +1076,5 @@
 }
 
-char *owl_command_aim(int argc, char **argv, char *buff)
+char *owl_command_aim(int argc, const char *const *argv, const char *buff)
 {
   if (argc<2) {
@@ -1096,5 +1096,5 @@
 }
 
-char *owl_command_addbuddy(int argc, char **argv, char *buff)
+char *owl_command_addbuddy(int argc, const char *const *argv, const char *buff)
 {
   if (argc!=3) {
@@ -1124,5 +1124,5 @@
 }
 
-char *owl_command_delbuddy(int argc, char **argv, char *buff)
+char *owl_command_delbuddy(int argc, const char *const *argv, const char *buff)
 {
   if (argc!=3) {
@@ -1148,5 +1148,5 @@
 }
 
-char *owl_command_join(int argc, char **argv, char *buff)
+char *owl_command_join(int argc, const char *const *argv, const char *buff)
 {
   if (argc!=3 && argc!=4) {
@@ -1172,7 +1172,7 @@
 }
 
-char *owl_command_startup(int argc, char **argv, char *buff)
-{
-  char *ptr;
+char *owl_command_startup(int argc, const char *const *argv, const char *buff)
+{
+  const char *ptr;
 
   if (argc<2) {
@@ -1193,7 +1193,7 @@
 }
 
-char *owl_command_unstartup(int argc, char **argv, char *buff)
-{
-  char *ptr;
+char *owl_command_unstartup(int argc, const char *const *argv, const char *buff)
+{
+  const char *ptr;
 
   if (argc<2) {
@@ -1213,5 +1213,5 @@
 }
 
-char *owl_command_dump(int argc, char **argv, char *buff)
+char *owl_command_dump(int argc, const char *const *argv, const char *buff)
 {
   char *filename;
@@ -1227,5 +1227,5 @@
 }
 
-char *owl_command_source(int argc, char **argv, char *buff)
+char *owl_command_source(int argc, const char *const *argv, const char *buff)
 {
   if (argc!=2) {
@@ -1238,5 +1238,5 @@
 }
 
-char *owl_command_next(int argc, char **argv, char *buff)
+char *owl_command_next(int argc, const char *const *argv, const char *buff)
 {
   char *filter=NULL;
@@ -1268,5 +1268,5 @@
 }
 
-char *owl_command_prev(int argc, char **argv, char *buff)
+char *owl_command_prev(int argc, const char *const *argv, const char *buff)
 {
   char *filter=NULL;
@@ -1298,5 +1298,5 @@
 }
 
-char *owl_command_smartnarrow(int argc, char **argv, char *buff)
+char *owl_command_smartnarrow(int argc, const char *const *argv, const char *buff)
 {
   char *filtname = NULL;
@@ -1316,5 +1316,5 @@
 }
 
-char *owl_command_smartfilter(int argc, char **argv, char *buff)
+char *owl_command_smartfilter(int argc, const char *const *argv, const char *buff)
 {
   char *filtname = NULL;
@@ -1372,5 +1372,5 @@
 }
 
-char *owl_command_loadsubs(int argc, char **argv, char *buff)
+char *owl_command_loadsubs(int argc, const char *const *argv, const char *buff)
 {
   if (argc == 2) {
@@ -1386,5 +1386,5 @@
 
 
-char *owl_command_loadloginsubs(int argc, char **argv, char *buff)
+char *owl_command_loadloginsubs(int argc, const char *const *argv, const char *buff)
 {
   if (argc == 2) {
@@ -1404,5 +1404,5 @@
 }
 
-char *owl_command_start_command(int argc, char **argv, char *buff)
+char *owl_command_start_command(int argc, const char *const *argv, const char *buff)
 {
   buff = skiptokens(buff, 1);
@@ -1411,5 +1411,5 @@
 }
 
-char *owl_command_zaway(int argc, char **argv, char *buff)
+char *owl_command_zaway(int argc, const char *const *argv, const char *buff)
 {
   if ((argc==1) ||
@@ -1437,5 +1437,5 @@
 
 
-char *owl_command_aaway(int argc, char **argv, char *buff)
+char *owl_command_aaway(int argc, const char *const *argv, const char *buff)
 {
   if ((argc==1) ||
@@ -1463,5 +1463,5 @@
 
 
-char *owl_command_away(int argc, char **argv, char *buff)
+char *owl_command_away(int argc, const char *const *argv, const char *buff)
 {
   if ((argc==1) ||
@@ -1506,7 +1506,7 @@
 }
 
-char *owl_command_set(int argc, char **argv, char *buff)
-{
-  char *var, *val;
+char *owl_command_set(int argc, const char *const *argv, const char *buff)
+{
+  const char *var, *val;
   int  silent=0;
   int requirebool=0;
@@ -1537,7 +1537,7 @@
 }
 
-char *owl_command_unset(int argc, char **argv, char *buff)
-{
-  char *var, *val;
+char *owl_command_unset(int argc, const char *const *argv, const char *buff)
+{
+  const char *var, *val;
   int  silent=0;
 
@@ -1557,7 +1557,7 @@
 }
 
-char *owl_command_print(int argc, char **argv, char *buff)
-{
-  char *var;
+char *owl_command_print(int argc, const char *const *argv, const char *buff)
+{
+  const char *var;
   char valbuff[1024];
 
@@ -1582,35 +1582,35 @@
 
 
-char *owl_command_exec(int argc, char **argv, char *buff)
+char *owl_command_exec(int argc, const char *const *argv, const char *buff)
 {
   return owl_function_exec(argc, argv, buff, 0);
 }
 
-char *owl_command_pexec(int argc, char **argv, char *buff)
+char *owl_command_pexec(int argc, const char *const *argv, const char *buff)
 {
   return owl_function_exec(argc, argv, buff, 1);
 }
 
-char *owl_command_aexec(int argc, char **argv, char *buff)
+char *owl_command_aexec(int argc, const char *const *argv, const char *buff)
 {
   return owl_function_exec(argc, argv, buff, 2);
 }
 
-char *owl_command_perl(int argc, char **argv, char *buff)
+char *owl_command_perl(int argc, const char *const *argv, const char *buff)
 {
   return owl_function_perl(argc, argv, buff, 0);
 }
 
-char *owl_command_pperl(int argc, char **argv, char *buff)
+char *owl_command_pperl(int argc, const char *const *argv, const char *buff)
 {
   return owl_function_perl(argc, argv, buff, 1);
 }
 
-char *owl_command_aperl(int argc, char **argv, char *buff)
+char *owl_command_aperl(int argc, const char *const *argv, const char *buff)
 {
   return owl_function_perl(argc, argv, buff, 2);
 }
 
-char *owl_command_multi(int argc, char **argv, char *buff)
+char *owl_command_multi(int argc, const char *const *argv, const char *buff)
 {
   char *lastrv = NULL, *newbuff;
@@ -1647,5 +1647,5 @@
 
 
-char *owl_command_alias(int argc, char **argv, char *buff)
+char *owl_command_alias(int argc, const char *const *argv, const char *buff)
 {
   if (argc < 3) {
@@ -1659,5 +1659,5 @@
 
 
-char *owl_command_bindkey(int argc, char **argv, char *buff)
+char *owl_command_bindkey(int argc, const char *const *argv, const char *buff)
 {
   owl_keymap *km;
@@ -1688,5 +1688,5 @@
 }
 
-char *owl_command_debug(int argc, char **argv, char *buff)
+char *owl_command_debug(int argc, const char *const *argv, const char *buff)
 {
   if (argc<2) {
@@ -1704,5 +1704,5 @@
 }
 
-char *owl_command_term(int argc, char **argv, char *buff)
+char *owl_command_term(int argc, const char *const *argv, const char *buff)
 {
   if (argc<2) {
@@ -1721,5 +1721,5 @@
 }
 
-char *owl_command_zlog(int argc, char **argv, char *buff)
+char *owl_command_zlog(int argc, const char *const *argv, const char *buff)
 {
   if ((argc<2) || (argc>3)) {
@@ -1745,7 +1745,7 @@
 }
 
-char *owl_command_subscribe(int argc, char **argv, char *buff)
-{
-  char *class, *instance, *recip="";
+char *owl_command_subscribe(int argc, const char *const *argv, const char *buff)
+{
+  const char *class, *instance, *recip="";
   int temp=0;
   int ret=0;
@@ -1795,7 +1795,7 @@
 
 
-char *owl_command_unsubscribe(int argc, char **argv, char *buff)
-{
-  char *class, *instance, *recip="";
+char *owl_command_unsubscribe(int argc, const char *const *argv, const char *buff)
+{
+  const char *class, *instance, *recip="";
   int temp=0;
 
@@ -1843,5 +1843,5 @@
 }
 
-char *owl_command_echo(int argc, char **argv, char *buff)
+char *owl_command_echo(int argc, const char *const *argv, const char *buff)
 {
   buff = skiptokens(buff, 1);
@@ -1860,5 +1860,5 @@
 }
 
-char *owl_command_zwrite(int argc, char **argv, char *buff)
+char *owl_command_zwrite(int argc, const char *const *argv, const char *buff)
 {
   owl_zwrite z;
@@ -1884,8 +1884,8 @@
 }
 
-char *owl_command_aimwrite(int argc, char **argv, char *buff)
+char *owl_command_aimwrite(int argc, const char *const *argv, const char *buff)
 {
   char *newbuff, *recip;
-  char **myargv;
+  const char *const *myargv;
   int i, j, myargc;
   owl_message *m;
@@ -1964,5 +1964,5 @@
 }
 
-char *owl_command_loopwrite(int argc, char **argv, char *buff)
+char *owl_command_loopwrite(int argc, const char *const *argv, const char *buff)
 {
   owl_function_loopwrite_setup();
@@ -1970,5 +1970,5 @@
 }
 
-char *owl_command_zcrypt(int argc, char **argv, char *buff)
+char *owl_command_zcrypt(int argc, const char *const *argv, const char *buff)
 {
 #ifdef OWL_ENABLE_ZCRYPT
@@ -1998,5 +1998,5 @@
 }
 
-char *owl_command_reply(int argc, char **argv, char *buff)
+char *owl_command_reply(int argc, const char *const *argv, const char *buff)
 {
   int edit=0;
@@ -2024,5 +2024,5 @@
 }
 
-char *owl_command_filter(int argc, char **argv, char *buff)
+char *owl_command_filter(int argc, const char *const *argv, const char *buff)
 {
   owl_function_create_filter(argc, argv);
@@ -2030,5 +2030,5 @@
 }
 
-char *owl_command_zlocate(int argc, char **argv, char *buff)
+char *owl_command_zlocate(int argc, const char *const *argv, const char *buff)
 {
   int auth;
@@ -2064,5 +2064,5 @@
  * view --home
  */
-char *owl_command_view(int argc, char **argv, char *buff)
+char *owl_command_view(int argc, const char *const *argv, const char *buff)
 {
   /* First take the 'view --home' and 'view -r' cases */
@@ -2088,8 +2088,8 @@
   /* Now get 'view -d <expression>' */
   if (argc>=3 && !strcmp(argv[1], "-d")) {
-    char **myargv;
+    const char **myargv;
     int i;
 
-    myargv=owl_malloc((argc*sizeof(char *))+50);
+    myargv=owl_malloc((argc*sizeof(const char *))+50);
     myargv[0]="";
     myargv[1]="owl-dynamic";
@@ -2136,5 +2136,5 @@
       argv++;
     } else if (!strcmp(argv[0], "-r")) {
-      char *foo;
+      const char *foo;
       foo=owl_function_create_negative_filter(owl_view_get_filtname(owl_global_get_current_view(&g)));
       owl_function_change_currentview_filter(foo);
@@ -2156,5 +2156,5 @@
 }
 
-char *owl_command_show(int argc, char **argv, char *buff)
+char *owl_command_show(int argc, const char *const *argv, const char *buff)
 {
   if (argc<2) {
@@ -2213,5 +2213,5 @@
     owl_function_show_quickstart();
   } else if (!strcmp(argv[1], "startup")) {
-    char *filename;
+    const char *filename;
     
     filename=owl_global_get_startupfile(&g);
@@ -2226,5 +2226,5 @@
 }
 
-char *owl_command_viewclass(int argc, char **argv, char *buff)
+char *owl_command_viewclass(int argc, const char *const *argv, const char *buff)
 {
   char *filtname;
@@ -2239,5 +2239,5 @@
 }
 
-char *owl_command_viewuser(int argc, char **argv, char *buff)
+char *owl_command_viewuser(int argc, const char *const *argv, const char *buff)
 {
   char *filtname;
@@ -2258,5 +2258,5 @@
 }
 
-char *owl_command_delete(int argc, char **argv, char *buff)
+char *owl_command_delete(int argc, const char *const *argv, const char *buff)
 {
   int move_after = 1;
@@ -2292,5 +2292,5 @@
 }
 
-char *owl_command_undelete(int argc, char **argv, char *buff)
+char *owl_command_undelete(int argc, const char *const *argv, const char *buff)
 {
   int move_after = 1;
@@ -2326,5 +2326,5 @@
 }
 
-char *owl_command_colorview(int argc, char **argv, char *buff)
+char *owl_command_colorview(int argc, const char *const *argv, const char *buff)
 {
   if (argc < 2 || argc > 3) {
@@ -2336,7 +2336,7 @@
 }
 
-char *owl_command_colorclass(int argc, char **argv, char *buff)
-{
-  char *filtname;
+char *owl_command_colorclass(int argc, const char *const *argv, const char *buff)
+{
+  const char *filtname;
   
   if (argc < 3 || argc > 4) {
@@ -2350,5 +2350,5 @@
 }
 
-char *owl_command_zpunt(int argc, char **argv, char *buff)
+char *owl_command_zpunt(int argc, const char *const *argv, const char *buff)
 {
   owl_command_zpunt_and_zunpunt(argc, argv, 0);
@@ -2356,5 +2356,5 @@
 }
 
-char *owl_command_zunpunt(int argc, char **argv, char *buff)
+char *owl_command_zunpunt(int argc, const char *const *argv, const char *buff)
 {
   owl_command_zpunt_and_zunpunt(argc, argv, 1);
@@ -2362,10 +2362,10 @@
 }
 
-void owl_command_zpunt_and_zunpunt(int argc, char **argv, int type)
+void owl_command_zpunt_and_zunpunt(int argc, const char *const *argv, int type)
 {
   /* if type==0 then zpunt
    * if type==1 then zunpunt
    */
-  char *class, *inst, *recip;
+  const char *class, *inst, *recip;
 
   class="message";
@@ -2399,5 +2399,5 @@
 }
 
-char *owl_command_smartzpunt(int argc, char **argv, char *buff)
+char *owl_command_smartzpunt(int argc, const char *const *argv, const char *buff)
 {
   if (argc == 1) {
@@ -2411,5 +2411,5 @@
 }
 
-char *owl_command_punt(int argc, char **argv, char *buff)
+char *owl_command_punt(int argc, const char *const *argv, const char *buff)
 {
   owl_command_punt_unpunt(argc, argv, buff, 0);
@@ -2417,5 +2417,5 @@
 }
 
-char *owl_command_unpunt(int argc, char **argv, char *buff)
+char *owl_command_unpunt(int argc, const char *const *argv, const char *buff)
 {
   owl_command_punt_unpunt(argc, argv, buff, 1);
@@ -2423,5 +2423,5 @@
 }
 
-void owl_command_punt_unpunt(int argc, char ** argv, char *buff, int unpunt)
+void owl_command_punt_unpunt(int argc, const char *const * argv, const char *buff, int unpunt)
 {
   owl_list * fl;
@@ -2457,7 +2457,7 @@
 
 
-char *owl_command_getview(int argc, char **argv, char *buff)
-{
-  char *filtname;
+char *owl_command_getview(int argc, const char *const *argv, const char *buff)
+{
+  const char *filtname;
   if (argc != 1) {
     owl_function_makemsg("Wrong number of arguments for %s", argv[0]);
@@ -2469,5 +2469,5 @@
 }
 
-char *owl_command_getvar(int argc, char **argv, char *buff)
+char *owl_command_getvar(int argc, const char *const *argv, const char *buff)
 {
   char tmpbuff[1024];
@@ -2483,5 +2483,5 @@
 }
 
-char *owl_command_getfilter(int argc, char **argv, char *buf)
+char *owl_command_getfilter(int argc, const char *const *argv, const char *buf)
 {
   owl_filter *f;
@@ -2497,8 +2497,8 @@
 }
 
-char *owl_command_search(int argc, char **argv, char *buff)
+char *owl_command_search(int argc, const char *const *argv, const char *buff)
 {
   int direction;
-  char *buffstart;
+  const char *buffstart;
 
   direction=OWL_DIRECTION_DOWNWARDS;
@@ -2518,7 +2518,7 @@
 }
 
-char *owl_command_setsearch(int argc, char **argv, char *buff)
-{
-  char *buffstart;
+char *owl_command_setsearch(int argc, const char *const *argv, const char *buff)
+{
+  const char *buffstart;
 
   buffstart=skiptokens(buff, 1);
@@ -2528,5 +2528,5 @@
 }
 
-char *owl_command_aimlogin(int argc, char **argv, char *buff)
+char *owl_command_aimlogin(int argc, const char *const *argv, const char *buff)
 {
   if ((argc<2) || (argc>3)) {
@@ -2549,5 +2549,5 @@
 }
 
-char *owl_command_aimlogout(int argc, char **argv, char *buff)
+char *owl_command_aimlogout(int argc, const char *const *argv, const char *buff)
 {
   /* clear the buddylist */
@@ -2558,7 +2558,7 @@
 }
 
-char *owl_command_getstyle(int argc, char **argv, char *buff)
-{
-  char *stylename;
+char *owl_command_getstyle(int argc, const char *const *argv, const char *buff)
+{
+  const char *stylename;
   if (argc != 1) {
     owl_function_makemsg("Wrong number of arguments for %s", argv[0]);
@@ -2570,5 +2570,5 @@
 }
 
-char *owl_command_error(int argc, char **argv, char *buff)
+char *owl_command_error(int argc, const char *const *argv, const char *buff)
 {
     buff = skiptokens(buff, 1);
@@ -2577,5 +2577,5 @@
 }
 
-char *owl_command_message(int argc, char **argv, char *buff)
+char *owl_command_message(int argc, const char *const *argv, const char *buff)
 {
     buff = skiptokens(buff, 1);
@@ -2588,5 +2588,5 @@
   owl_message *m;
   owl_view *v;
-  char *cmd;
+  const char *cmd;
 
   v = owl_global_get_current_view(&g);
@@ -2622,5 +2622,5 @@
   owl_message *m;
   owl_view *v;
-  char *cmd;
+  const char *cmd;
 
   v = owl_global_get_current_view(&g);
@@ -2680,5 +2680,5 @@
 {
   owl_history *hist;
-  char *ptr;
+  const char *ptr;
 
   hist=owl_editwin_get_history(e);
@@ -2701,5 +2701,5 @@
 {
   owl_history *hist;
-  char *ptr;
+  const char *ptr;
 
   hist=owl_editwin_get_history(e);
@@ -2715,5 +2715,5 @@
 }
 
-char *owl_command_edit_insert_text(owl_editwin *e, int argc, char **argv, char *buff)
+char *owl_command_edit_insert_text(owl_editwin *e, int argc, const char *const *argv, const char *buff)
 {
   buff = skiptokens(buff, 1);
Index: dict.c
===================================================================
--- dict.c	(revision 2b37be24365a6f7a551e5e5fa5d7e57f9a5b7d2f)
+++ dict.c	(revision e19eb97bacd75cf02905ec2b7a6a73b9642b907a)
@@ -31,5 +31,5 @@
  * this element would logically go, and stores the index in pos.
  * Returns 1 if found, else 0. */
-int _owl_dict_find_pos(owl_dict *d, char *k, int *pos) {
+int _owl_dict_find_pos(owl_dict *d, const char *k, int *pos) {
   int lo = 0, hi = d->size;
   while (lo < hi) {
@@ -50,5 +50,5 @@
 
 /* returns the value corresponding to key k */
-void *owl_dict_find_element(owl_dict *d, char *k) {
+void *owl_dict_find_element(owl_dict *d, const char *k) {
   int found, pos;
   found = _owl_dict_find_pos(d, k, &pos);
@@ -82,5 +82,5 @@
    Will return -2 if replace=NULL and match was found.
 */
-int owl_dict_insert_element(owl_dict *d, char *k, void *v, void (*free_on_replace)(void *old)) {
+int owl_dict_insert_element(owl_dict *d, const char *k, void *v, void (*free_on_replace)(void *old)) {
   int pos, found;
   char *dupk;
@@ -113,5 +113,5 @@
 /* Doesn't free the value of the element, but does
  * return it so the caller can free it. */
-void *owl_dict_remove_element(owl_dict *d, char *k) {
+void *owl_dict_remove_element(owl_dict *d, const char *k) {
   int i;
   int pos, found;
